<?php
/***********************************************************
* op_header_class() - Header class, checks if feed is displayed
* Almost useless at this point
***********************************************************/
function op_header_class($op_feed) {
	if($op_feed == __('True','options')) echo 'feed-inside';
}

/***********************************************************
* op_title_bar() - Display better titles (top of browser window)
***********************************************************/
function op_title_bar() {
	global $post;
	if(is_single() || is_page()) $subtitle = get_post_meta($post->ID, 'Subtitle', $single = true);

	if(is_front_page()) :
		echo bloginfo('name'); echo ": "; echo bloginfo('description');
	elseif(is_404()) :
		_e('404 Not Found','options');
	elseif(is_category()) :
		single_cat_title(__('Category: ','options'));
	elseif(is_tag()) :
		single_tag_title(__('Tag: ','options'));
	elseif(is_search()) :
		_e('Search Results:','options'); echo ' '; the_search_query();
	elseif(is_archive()) :
		_e('Archives:','options'); wp_title('');
	elseif(is_attachment()) :
		_e('Attachment:','options'); wp_title('');
	else :
		echo wp_title('');
		if((is_single() || is_page()) && $subtitle !== '') echo ': ' . $subtitle;
	endif;
}

/***********************************************************
* op_page_id() - Returns page ID
***********************************************************/
function op_page_id() {
	global $no_sidebar;

	if(is_page_template('no-sidebar.php')) : $blog_page_id = 'no-sidebar';
	elseif(is_home()) : $blog_page_id = 'home';
	else : $blog_page_id = 'content';
	endif;

	return $blog_page_id;
}

/***********************************************************
* op_get_page_id() - Returns page ID
***********************************************************/
function op_get_page_id() {
	$page_id = op_page_id();
	return $page_id;
}

/***********************************************************
* op_page_class() - Returns page class
***********************************************************/
function op_page_class($sidebar_display = 'Right') {
	if(is_home()) : $page_class = 'home';
	elseif(is_attachment()) : $page_class = 'attachment';
	elseif(is_single()) : $page_class = 'single';
	elseif(is_page()) : $page_class = 'page';
	elseif (is_404()) : $page_class = 'error-404';
	elseif (is_category()) : $page_class = 'category';
	elseif(is_tag()) : $page_class = 'tag';
	elseif(is_author()) : $page_class = 'author';
	elseif(is_search()) : $page_class = 'search';
	elseif(is_archive()) : $page_class = 'archive';
	endif;

	if(is_paged()) $page_class .= ' paged';

	if($sidebar_display == false) $page_class = $page_class;
	elseif($sidebar_display == __('Right','options')) $page_class .= ' left';
	else $page_class .= ' right';

	return $page_class;
}

/***********************************************************
* op_get_navigation() - Includes the correct navigation
* Called in header.php
***********************************************************/
function op_get_navigation($op_nav_display,$op_nav) {
	if($op_nav_display == 'above') :
		if($op_nav == __('Main Nav Above','options')) :
			include(TEMPLATEPATH."/main-nav.php");
		elseif($op_nav == __('Main and Sub-Nav Above','options')) :
			include(TEMPLATEPATH."/main-nav.php");
			include(TEMPLATEPATH."/sub-nav.php");
		elseif($op_nav == __('Main Above and Sub-Nav Below','options')) :
			include(TEMPLATEPATH."/main-nav.php");
		else : echo '';
		endif;
	elseif($op_nav_display == 'below') :
		if($op_nav == __('Main Nav Below','options')) :
			include(TEMPLATEPATH."/main-nav.php");
		elseif($op_nav == __('Main and Sub-Nav Below','options')) :
			include(TEMPLATEPATH."/main-nav.php");
			include(TEMPLATEPATH."/sub-nav.php");
		elseif($op_nav == __('Main Above and Sub-Nav Below','options')) :
			include(TEMPLATEPATH."/sub-nav.php");
		else : echo '';
		endif;
	endif;
}

/***********************************************************
* op_get_feed() - Includes file /includes/header-feed.php if true
***********************************************************/
// Display the feed/subscribe section in header
function op_get_feed($feed_links) {
	if($feed_links == __('True','options')) include(TEMPLATEPATH . '/includes/header-feed.php');
}

/***********************************************************
* op_sidebar_pos() - Position the sidebar
* "None" isn't yet available (probably never will be).
***********************************************************/
function op_sidebar_pos() {
	global $op_sidebar_placement;
	if($op_sidebar_placement == __('None','options')) : $op_sidebar = 'no-sidebar';
	elseif($op_sidebar_placement == __('Right','options')) : $op_sidebar = 'right';
	elseif($op_sidebar_placement == __('Left','options')) : $op_sidebar = 'left';
	else : $op_sidebar = 'right';
	endif;
	echo $op_sidebar;
}
?>