<?php
/***********************************************************
* These functions are for use within the loop.
***********************************************************/

/***********************************************************
* breadcrumb() - Shows a breadcrumb for single and page
* Needs better depth control w/pages
* @since 1.0
***********************************************************/
function breadcrumb($crumbs = true, $title = 'Browse', $separator = '&#0047;') {
?>
	<div class="breadcrumb section">
	<?php
		if($title !== __('Browse','options')) echo $title;
		else _e('Browse','options'); 
	?>:
		<a href="<?php bloginfo('url'); ?>" title="<?php bloginfo('name'); ?>"><?php _e('Home','options'); ?></a> <?php echo $separator; ?> 
	<?php
		if(is_single()) :
			the_category(', '); echo ' ' . $separator . ' ';
		elseif(is_page()) :
			$parent_id = $post->post_parent;
			$parents = array();
			while($parent_id) :
				$page = get_page($parent_id);
				if($params["link_none"]) $parents[]  = get_the_title($page->ID);
				else $parents[]  = '<a href="'.get_permalink($page->ID).'" title="'.get_the_title($page->ID).'">'.get_the_title($page->ID).'</a> ' . $separator . ' ';
			$parent_id  = $page->post_parent;
			endwhile;
			echo $parents[0];
		endif;
		the_title(); ?>
	</div>
<?php
}

/***********************************************************
* op_related_posts() - Shows related posts by plugin
* @since 1.1
* @plugin - http://wasabi.pbwiki.com/Related%20Entries
***********************************************************/
function op_related_posts() {
	if(function_exists('related_posts')) {
		echo '<div id="related" class="section">';
		echo '<h3 class="section-header">'; _e('Related Posts','options'); echo '</h3>';
		echo '<ul>'; related_posts(); echo '</ul>';
		echo "</div>\n";
	}
}

/***********************************************************
* limit_content() - Returns excerpt by variable count #
* @since 1.0
***********************************************************/
function limit_content($max_char, $more_link_text = '(more...)', $stripteaser = 0, $more_file = '') {
	if(is_numeric($max_char) && $max_char > 1) :
		$max_char = (int)$max_char;
		$title = get_the_title();
		$title = apply_filters('the_title', $title);
		$title = strip_tags($title);
		$title = strlen($title);
		$max_char = $max_char - $title;
		$content = get_the_content($more_link_text, $stripteaser, $more_file);
		$content = apply_filters('the_content', $content);
		$content = str_replace(']]>', ']]&gt;', $content);
		$content = strip_tags($content);
		$char = $content;
		if((strlen($char)>$max_char) && ($espacio = strpos($char, " ", $max_char ))) {
			$content = substr($content, 0, $espacio); $content = $content;
			echo "<p class='read-more'>"; echo $content; echo "..."; echo "&nbsp;<a href='"; the_permalink();
			echo "' title='"; the_title(); echo "'>".$more_link_text."</a>"; echo "</p>";
		}
		elseif(strlen($_GET['p']) > 0) {
			echo "<p class='read-more'>"; echo $content; echo "&nbsp;<a href='"; the_permalink(); echo "'title='"; the_title(); echo "'>".__('Read More &raquo;','options')."</a>"; echo "</p>";
		}
		else {
			echo "<p class='read-more'>"; echo $content; echo "&nbsp;<a href='"; the_permalink();
			echo "' title='"; the_title(); echo "'>".__('Read More &raquo;','options')."</a>"; echo "</p>";
		}
	endif;
}
?>