<?php
/************************************************
Need to update some variable names in future releases.
Development shouldn't be too confusing.
************************************************/
// Theme options
function op_options_theme_settings() {

// Stylesheets
	$styled = style_files();
	$styled = $styled['style_name'];
	foreach($styled as $key => $value) :
		$styled_arr[$key] = $value;
	endforeach;
	$styled_arr[] = __('None','options');

// Array of home sections to shorten code later
// Reuse and recycle for the good of the WP environment
	$home_sections_arr = array(
		__('None','options'),
		__('Author Cloud','options'),
		__('Category Cloud','options'),
		__('Excerpts','options'),
		__('Feature','options'),
		__('Features Gallery','options'),
		__('Features Numbers','options'),
		__('Flickr Photos','options'),
		__('Full Posts','options'),
		__('Gallery Stream','options'),
		__('Post Blocks','options'),
		__('Post Block Tabs','options'),
		__('Post List Tabs','options'),
		__('Post Sections','options'),
		__('Post Tabs','options'),
		__('Tag Cloud','options'),
		__('Video Numbers','options'),
		__('Video Tabbed','options'),
		__('Custom 1','options'),
		__('Custom 2','options'),
		__('Custom 3','options')
	);
	$home_arr_val = array_values($home_sections_arr);

// Get choices of tags/categories from the config file
// Users must manually set this for now
	$op_section_tab = choose_tab_type();
	if($op_section_tab == __('Tags','options')) $all_arr = op_all_tag_names();
	elseif($op_section_tab == __('Authors','options'))
		$all_arr = op_all_authors();
	else
		$all_arr = op_all_cats();

// Options array
	$themename = __('Options Theme','options');
	$shortname = "op";
	$options = array (
	// Stylesheet options
		array('name' => __('Theme Stylesheet','options'),
		'id' => $shortname.'_style',
		'std' => $styled_arr[0],
		'type' => 'select',
		'options' => $styled_arr),
	// Home page layout options
		array('name' => __('Home Section 1','options'),
			'id' => $shortname.'_home_1',
			'std' => __('Excerpts','options'),
			'type' => 'select',
			'options' => $home_sections_arr),
		array('name' => __('Home Section 2','options'),
			'id' => $shortname."_home_2",
			'std' => __('None','options'),
			'type' => 'select',
			'options' => $home_sections_arr),
		array("name" => __('Home Section 3','options'),
			"id" => $shortname."_home_3",
			"std" => __('None','options'),
			"type" => "select",
			"options" => $home_sections_arr),
		array("name" => __('Home Section 4','options'),
			"id" => $shortname."_home_4",
			"std" => __('None','options'),
			"type" => "select",
			"options" => $home_sections_arr),
		array("name" => __('Home Section 5','options'),
			"id" => $shortname."_home_5",
			"std" => __('None','options'),
			"type" => "select",
			"options" => $home_sections_arr),
	// Sidebar placement
		array("name" => __('Sidebar Placement','options'),
			"id" => $shortname."_sidebar_pos",
			"std" => __('Right','options'),
			"type" => "select",
			"options" => array(__('Right','options'),__('Left','options'))),
	// Feed URLs and placement
		array("name" => __('Feed Links In Header?','options'),
			"id" => $shortname."_feed_links",
			"std" => __('False','options'),
			"type" => "select",
			"options" => array(__('True','options'),__('False','options'))),
		array("name" => __('Feed URL','options'),
			"id" => $shortname."_feed_url",
			"std" => "",
			"type" => "text"),
		array("name" => __('Feed By Email URL','options'),
			"id" => $shortname."_feed_email",
			"std" => "",
			"type" => "text"),
	// Navigation menu options
		array("name" => __('Navigation Display','options'),
			"id" => $shortname."_nav",
			"std" => __('Main Nav Below','options'),
			"type" => "select",
			"options" => array(__('Main Nav Below','options'),__('Main and Sub-Nav Below','options'),__('Main Nav Above','options'),__('Main and Sub-Nav Above','options'),__('Main Above and Sub-Nav Below','options'),__('None','options'))),
	// Search box placement
		array("name" => __('Search box in navigation?','options'),
			"id" => $shortname."_search",
			"std" => __('True','options'),
			"type" => "select",
			"options" => array(__('True','options'),__('False','options'))),
	// Categories for any of the category options
		array("name" => __('Tab/Section 1','options'),
			"id" => $shortname."_cat_1",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr),
		array("name" => __('Tab/Section 2','options'),
			"id" => $shortname."_cat_2",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr),
		array("name" => __('Tab/Section 3','options'),
			"id" => $shortname."_cat_3",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr),
		array("name" => __('Tab/Section 4','options'),
			"id" => $shortname."_cat_4",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr),
		array("name" => __('Tab/Section 5','options'),
			"id" => $shortname."_cat_5",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr),
		array("name" => __('Tab/Section 6','options'),
			"id" => $shortname."_cat_6",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr),
		array("name" => __('Tab/Section 7','options'),
			"id" => $shortname."_cat_7",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr),
		array("name" => __('Tab/Section 8','options'),
			"id" => $shortname."_cat_8",
			"std" => $all_arr['none'],
			"type" => "select",
			"options" => $all_arr)
	);
	$options_theme_settings = array('theme_name' => $themename, 'short_name' => $shortname, 'options' => $options);
	return $options_theme_settings;
}

// Stylesheet files
function style_files() {
	$style_files = get_styles(TEMPLATEPATH . '/styles/');
	foreach($style_files as $style_file) :
		$theme_data = get_theme_data(TEMPLATEPATH.'/styles/'.$style_file);
		$style_name[] = $theme_data['Title'];
		$stylesheet= $style_file;
	endforeach;
	$styled = array('style_name' => $style_name, 'stylesheet' => $stylesheet);
	return $styled;
}
function get_styles($op_style_path) {
	return op_scan_files($op_style_path, 'css', 2);
}
?>