<?php
/*
Template Name: Blog
Description: If you want to set up an alternate blog page, just use this template for your page.
*/
?>

<?php get_header(); ?>

<?php
	$posts_wanted = get_option('posts_per_page');
	query_posts("showposts=$posts_wanted");
	$post_class = 'odd';
?>

<?php if(have_posts()) : while(have_posts()) : the_post(); ?>

	<div class="post <?php echo $post_class; ?>">

		<h2>
			<a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><?php the_title(); ?></a>
		</h2>

		<p class="byline">
			<?php _e('By '); ?> <?php the_author_posts_link(); ?> &bull; 
			<?php the_time(__('F j, Y','options')); ?> &bull; 
			<?php comments_popup_link(__('No Comments','options'), '1 '.__('Comment','options'), '% '.__('Comments','options')); ?>
			<?php edit_post_link('<span class="edit-post">'.__('[Edit]','options').'</span>', ' ', ''); ?>
		</p>

		<div class="entry">
			<?php the_content(__('Read more &raquo;','options')); ?>
		</div>
		
		<div class="post-meta-data">
			<p>
				<span class="categories"><?php _e('Categories: ','options'); ?> <?php the_category(', '); ?></span>
				<br />
				<span class="tags"><?php _e('Tags: ','options'); ?> <?php the_tags('', ', ', ''); ?></span>
			</p>
		</div>
	</div>

	<?php
		if('odd' == $post_class) $post_class = 'even';
		else $post_class == 'odd';
	?>

	<?php endwhile; ?>

<?php else: ?>

	<p><?php _e('Sorry, no posts matched your criteria.','options'); ?></p>

<?php endif; ?>

<?php get_footer(); ?>