<?php
function widget_op_gallery_stream($args, $widget_args = 1) {
// Extract arguments
	extract( $args, EXTR_SKIP );
	if ( is_numeric($widget_args) )
		$widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
	extract( $widget_args, EXTR_SKIP );

	$options = get_option('widget_op_gallery_stream');
	if ( !isset($options[$number]) )
		return;
// Set the variables to nice names
	$cat_name = $options[$number]['t2'];
	$tag_name = $options[$number]['t3'];
// Set the query and run it
	if($cat_name == true) $query_var = "category_name=$cat_name"; //$query_var = cleaner_query('category',$cat_name);
	elseif($tag_name == true) $query_var = cleaner_query('tag',$tag_name);
	query_posts("$query_var&showposts=1");
	while(have_posts()) : the_post();
	global $post;

	echo $before_widget;

	echo $before_title; ?>
		<a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><?php the_title(); ?></a>
	<?php echo $after_title;
		echo "<div class=\"gallery-stream\">\n";
		// Get image attachments
			// $attachments = get_children("post_parent=$post->ID&post_type=attachment&post_mime_type=image&orderby=\"menu_order ASC, ID ASC\"&numberposts=6");
			$attachments = get_children( array('post_parent' => $post->ID, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => 'ASC', 'orderby' => 'menu_order ID', 'numberposts' => 6) );
		// Get each attachment image and link to attachment page
			foreach ( $attachments as $id => $attachment ) :
				setup_postdata($id);
				$att_page = get_attachment_link($id);
				echo wp_get_attachment_link($id, 'thumbnail', true);
			endforeach;
		echo "</div>\n";
	endwhile;
	wp_reset_query();
	echo $after_widget;
}

function widget_op_gallery_stream_control($widget_args) {
	global $wp_registered_widgets;
	static $updated = false;

	if(is_numeric($widget_args)) $widget_args = array('number' => $widget_args);
	$widget_args = wp_parse_args( $widget_args, array('number' => -1));
	extract( $widget_args, EXTR_SKIP );

	$options = get_option('widget_op_gallery_stream');
	if(!is_array($options)) $options = array();

	if(!$updated && !empty($_POST['sidebar'])) {
		$sidebar = (string) $_POST['sidebar'];

		$sidebars_widgets = wp_get_sidebars_widgets();
		if(isset($sidebars_widgets[$sidebar])) $this_sidebar =& $sidebars_widgets[$sidebar];
		else $this_sidebar = array();

		foreach($this_sidebar as $_widget_id) {
			if('widget_op_gallery_stream' == $wp_registered_widgets[$_widget_id]['callback'] && isset($wp_registered_widgets[$_widget_id]['params'][0]['number'])) {
				$widget_number = $wp_registered_widgets[$_widget_id]['params'][0]['number'];
				unset($options[$widget_number]);
			}
		}
		foreach((array) $_POST['widget-op-gallery-stream'] as $widget_number => $widget_gallery_stream) {
			$t2 = strip_tags(stripslashes($widget_gallery_stream['t2']));
			$t3 = strip_tags(stripslashes($widget_gallery_stream['t3']));
			$options[$widget_number] = compact('t2','t3');
		}
		update_option('widget_op_gallery_stream', $options);
		$updated = true;
	}
	if(-1 == $number) {
		$t2 = '';
		$t3 = '';
		$number = '%i%';
	} else {
		$t2 = attribute_escape($options[$number]['t2']);
		$t3 = attribute_escape($options[$number]['t3']);
	}
?>
	<p><?php _e('Category (Overrides tag):','options'); ?>
	<select id="gallery-stream-t2-<?php echo $number; ?>" name="widget-op-gallery-stream[<?php echo $number; ?>][t2]" class="widefat">
	<?php $all_cats = op_all_cat_slugs();
		foreach($all_cats as $cat) :
			echo '<option '; if($cat == $t2) echo ' selected="selected" '; echo 'label="'.$cat.'">'.$cat.'</option>';
		endforeach;
	?></select></p>
	<p><?php _e('Tag:','options'); ?>
	<select id="gallery-stream-t3-<?php echo $number; ?>" name="widget-op-gallery-stream[<?php echo $number; ?>][t3]" class="widefat">
	<?php $all_tags = op_all_tags();
		foreach($all_tags as $tag) :
			echo '<option '; if($tag == $t3) echo ' selected="selected" '; echo 'label="'.$tag.'">'.$tag.'</option>';
		endforeach;
	?></select></p>
	<p>
	<input type="hidden" id="gallery-stream-submit-<?php echo $number; ?>" name="gallery-stream-submit-<?php echo $number; ?>" value="1" />
	</p>
<?php
}
/***********************************************************
	Register gallery widget
***********************************************************/
function widget_op_gallery_stream_register() {
// Check for the required API functions
	if(!function_exists('wp_register_sidebar_widget') || !function_exists('wp_register_widget_control')) return;
	if(!$options = get_option('widget_op_gallery_stream')) $options = array();
	$widget_ops = array('classname' => 'widget_op_gallery_stream', 'description' => __('Display your latest gallery post by category or tag.','options'));
	$control_ops = array('width' => 200, 'height' => 350, 'id_base' => 'gallery-stream');
	$name = __('Gallery Stream','options');
	$id = false;

	foreach(array_keys($options) as $o) {
		// Old widgets can have null values for some reason
		if(!isset($options[$o]['t2']) || !isset($options[$o]['t3']))
			continue;
		$id = "gallery-stream-$o"; // Never never never translate an id
		wp_register_sidebar_widget($id, $name, 'widget_op_gallery_stream', $widget_ops, array('number' => $o));
		wp_register_widget_control($id, $name, 'widget_op_gallery_stream_control', $control_ops, array('number' => $o));
	}
// If there are none, we register the widget's existance with a generic template
	if(!$id) {
		wp_register_sidebar_widget('gallery-stream-1', $name, 'widget_op_gallery_stream', $widget_ops, array('number' => -1));
		wp_register_widget_control('gallery-stream-1', $name, 'widget_op_gallery_stream_control', $control_ops, array('number' => -1));
	}	
}
?>