<?php
function widget_op_recent($args, $widget_args = 1) {
// Extract arguments
	extract( $args, EXTR_SKIP );
	if ( is_numeric($widget_args) )
		$widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
	extract( $widget_args, EXTR_SKIP );

	$options = get_option('widget_op_recent');
	if ( !isset($options[$number]) )
		return;
// Set the variables to nice names
	$section_header = $options[$number]['t1'];
	$cat_name = $options[$number]['t2'];
	$tag_name = $options[$number]['t3'];
	$posts_wanted = $options[$number]['t4'];
	$t5 = $options[$number]['t5'];
	$order = $options[$number]['t6'];
// Post order
	if($order == __('Random','options')) $order = "orderby=rand";
	else $order = "orderby=date";
// Custom fields display
	if($t5 == 'on') $custom_fields_display = true;
	else $custom_fields_display = false;
// Variables
	$excerpt = 125;
	$excerpt_more_text = __('Read More','options').' &raquo;';
	$odd_post = 'odd'; $i = 1;
// Set the query and run it
	if($cat_name == true) $query_var = "category_name=$cat_name"; //$query_var = cleaner_query('category',$cat_name);
	elseif($tag_name == true) $query_var = cleaner_query('tag',$tag_name);
	rewind_posts();
	query_posts("$order&$query_var&showposts=$posts_wanted");
?>

	<div class="recent menu">
		<?php if($section_header == true && $section_header !== '') echo $before_title . $section_header . $after_title; ?>

		<?php if(have_posts()) : while(have_posts()) : the_post(); ?>

			<div class="post <?php echo $odd_post; ?>">
				<?php if($custom_fields_display == true) echo get_the_image_link(array('Thumbnail'), 'thumbnail'); ?>
				<h3 class="post-title">
					<a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><?php the_title(); ?></a>
				</h3>
				<div class="entry">
					<?php limit_content($excerpt, $excerpt_more_text); ?>
				</div>
			</div>
	
			<?php
				if('odd' == $odd_post) $odd_post = 'even';
				else $odd_post == 'odd';
				$i++;
			?>
		<?php endwhile; endif; wp_reset_query(); ?>
	</div>
<?php
}

function widget_op_recent_control($widget_args) {
	global $wp_registered_widgets;
	static $updated = false;

	if(is_numeric($widget_args)) $widget_args = array('number' => $widget_args);
	$widget_args = wp_parse_args( $widget_args, array('number' => -1));
	extract( $widget_args, EXTR_SKIP );

	$options = get_option('widget_op_recent');
	if(!is_array($options)) $options = array();

	if(!$updated && !empty($_POST['sidebar'])) {
		$sidebar = (string) $_POST['sidebar'];

		$sidebars_widgets = wp_get_sidebars_widgets();
		if(isset($sidebars_widgets[$sidebar])) $this_sidebar =& $sidebars_widgets[$sidebar];
		else $this_sidebar = array();

		foreach($this_sidebar as $_widget_id) {
			if('widget_op_recent' == $wp_registered_widgets[$_widget_id]['callback'] && isset($wp_registered_widgets[$_widget_id]['params'][0]['number'])) {
				$widget_number = $wp_registered_widgets[$_widget_id]['params'][0]['number'];
				unset($options[$widget_number]);
			}
		}
		foreach((array) $_POST['widget-op-recent'] as $widget_number => $widget_recent) {
			$t1 = strip_tags(stripslashes($widget_recent['t1']));
			$t2 = strip_tags(stripslashes($widget_recent['t2']));
			$t3 = strip_tags(stripslashes($widget_recent['t3']));
			$t4 = strip_tags(stripslashes($widget_recent['t4']));
			$t5 = strip_tags(stripslashes($widget_recent['t5']));
			$t6 = strip_tags(stripslashes($widget_recent['t6']));
			$options[$widget_number] = compact('t1','t2','t3','t4','t5','t6');
		}
		update_option('widget_op_recent', $options);
		$updated = true;
	}
	if(-1 == $number) {
		$t1 = '';
		$t2 = '';
		$t3 = '';
		$t4 = '';
		$t5 = '';
		$t6 = '';
		$number = '%i%';
	} else {
		$t1 = attribute_escape($options[$number]['t1']);
		$t2 = attribute_escape($options[$number]['t2']);
		$t3 = attribute_escape($options[$number]['t3']);
		$t4 = attribute_escape($options[$number]['t4']);
		$t5 = attribute_escape($options[$number]['t5']);
		$t6 = attribute_escape($options[$number]['t6']);
	}
?>
	<p><label for="recent-t1-<?php echo "$number"; ?>"><?php _e('Title:','options'); ?>
	<input id="recent-t1-<?php echo "$number"; ?>" name="widget-op-recent[<?php echo $number; ?>][t1]" type="text" value="<?php echo $t1; ?>" style="width:100%;" /></label></p>
	<p><?php _e('Category (Overrides tag):','options'); ?>
	<select id="recent-t2-<?php echo $number; ?>" name="widget-op-recent[<?php echo $number; ?>][t2]" class="widefat">
	<?php $all_cats = op_all_cat_slugs();
		foreach($all_cats as $cat) :
			echo '<option '; if($cat == $t2) echo ' selected="selected" '; echo 'label="'.$cat.'">'.$cat.'</option>';
		endforeach;
	?></select></p>
	<p><?php _e('Tag:','options'); ?>
	<select id="recent-t3-<?php echo $number; ?>" name="widget-op-recent[<?php echo $number; ?>][t3]" class="widefat">
	<?php $all_tags = op_all_tags();
		foreach($all_tags as $tag) :
			echo '<option '; if($tag == $t3) echo ' selected="selected" '; echo 'label="'.$tag.'">'.$tag.'</option>';
		endforeach;
	?></select></p>
	<p><?php _e('Order by:','options'); ?>
	<select id="recent-t6-<?php echo $number; ?>" name="widget-op-recent[<?php echo $number; ?>][t6]" class="widefat">
	<?php
		$all_ord = array(__('Date','options'), __('Random','options'));
		foreach($all_ord as $ord) :
			echo '<option '; if($ord == $t6) echo ' selected="selected" '; echo 'label="'.$ord.'">'.$ord.'</option>';
		endforeach;
	?></select></p>
	<p><label for="recent-t4-<?php echo "$number"; ?>"><?php _e('Posts wanted:','options'); ?>
	<input id="recent-t4-<?php echo "$number"; ?>" name="widget-op-recent[<?php echo $number; ?>][t4]" type="text" value="<?php echo $t4; ?>" style="width:100%;" /></label></p>
	<p><?php _e('Show custom fields?', 'options'); ?>
	<input type="checkbox" id="recent-t5-<?php echo $number; ?>" name="widget-op-recent[<?php echo $number; ?>][t5]" <?php if($t5 == 'on') echo ' checked="checked"'; ?> /></label></p>
	<p>
	<input type="hidden" id="recent-submit-<?php echo $number; ?>" name="recent-submit-<?php echo $number; ?>" value="1" />
	</p>
<?php
}
/***********************************************************
	Register recent widget
***********************************************************/
function widget_op_recent_register() {
// Check for the required API functions
	if(!function_exists('wp_register_sidebar_widget') || !function_exists('wp_register_widget_control')) return;
	if(!$options = get_option('widget_op_recent')) $options = array();
	$widget_ops = array('classname' => 'widget_op_recent', 'description' => __('Display your posts by most recent, tag, or category.','options'));
	$control_ops = array('width' => 200, 'height' => 350, 'id_base' => 'recent');
	$name = __('Recent','options');
	$id = false;

	foreach(array_keys($options) as $o) {
		// Old widgets can have null values for some reason
		if(!isset($options[$o]['t1']) || !isset($options[$o]['t2']) || !isset($options[$o]['t3']) || !isset($options[$o]['t4']))
			continue;
		$id = "recent-$o"; // Never never never translate an id
		wp_register_sidebar_widget($id, $name, 'widget_op_recent', $widget_ops, array('number' => $o));
		wp_register_widget_control($id, $name, 'widget_op_recent_control', $control_ops, array('number' => $o));
	}
// If there are none, we register the widget's existance with a generic template
	if(!$id) {
		wp_register_sidebar_widget('recent-1', $name, 'widget_op_recent', $widget_ops, array('number' => -1));
		wp_register_widget_control('recent-1', $name, 'widget_op_recent_control', $control_ops, array('number' => -1));
	}	
}
?>